hdu 5072 coprime不完整题解

Problem Description
There are n people standing in a line. Each of them has a unique id number.

Now the Ragnarok is coming. We should choose 3 people to defend the evil. As a group, the 3 people should be able to communicate. They are able to communicate if and only if their id numbers are pairwise coprime or pairwise not coprime. In other words, if their id numbers are a, b, c, then they can communicate if and only if [(a, b) = (b, c) = (a, c) = 1] or [(a, b) ≠ 1 and (a, c) ≠ 1 and (b, c) ≠ 1], where (x, y) denotes the greatest common divisor of x and y.

We want to know how many 3-people-groups can be chosen from the n people.
 

Input
The first line contains an integer T (T ≤ 5), denoting the number of the test cases.

For each test case, the first line contains an integer n(3 ≤ n ≤ 10 5), denoting the number of people. The next line contains n distinct integers a 1, a 2, . . . , a n(1 ≤ a i ≤ 10 5) separated by a single space, where a i stands for the id number of the i-th person.
 

Output
For each test case, output the answer in a line.
 

Sample Input
  
  
1 5 1 3 9 10 2
 

Sample Output
  
  
4
 

Source

这几周花了好多时间在看代码,虽然明知道是容斥原理,但是搜遍百度得到的答案也就是容斥原理四个字,呵呵,算我学艺不精,先把题解留在这里等以后再完善吧。

题目大意:给一个数组,求出这些数字两两互质或者两两不互质的情况的个数。
题目思路:毫无疑问暴力绝对超时。于是我们把问题转换成求两两搭配的个数减去正好一个数a与另一个数b互质,a同时和另一个数c不互质的情况的个数。但这样求 一个数a与另一个数b互质,a同时和另一个数c不互质的情况的个数这个问题还稍显复杂,我们想想两个数之间不就只有互质和不互质的关系吗(也就是最大公约数为1和最大公约数不为1)?好了,接下来是网上搜到的比较易懂的代码(有些大神的代码真是看得眼晕,凡是主函数低于5行的都转得我眼晕)。
代码因为是很久搜到的,现在已经无法查明出处了,在这里要向原作者道歉,也希望有人提示一下原博客的网址(话说有人看么)。
#include <cstdio>
#include <cstring>
#include<iostream>
#include <cmath>
#include <vector>
using namespace std;
const int maxn = 100005;
int a[maxn], cnt[maxn];
vector <int> tmp;
int main() {
    int T, n, x;
    scanf("%d", &T);
    while(T--) {
        long long ans = 0;
        scanf("%d", &n);
        memset(a, 0, sizeof(a));
        memset(cnt, 0, sizeof(cnt));
        //a[x]表示x的个数有多少个
        for(int i = 0; i < n; i++) {
            scanf("%d", &x);
            a[x]++;
        }
        //cnt[i]表示数组中约数为i的个数
        for(int i = 1; i < maxn; i++) {
            for(int j = i; j < maxn; j += i) {
                cnt[i] += a[j];
            }
        }
        //tmp用来储存一个数字的所有质因数(好专业的样子)
        for(int i = 1; i < maxn; i++) {
            if(a[i]) {
                tmp.clear();
                int t = i;
                int u = (int)sqrt(i);
                for(int j = 2; j <= u; j++) {
                    if(t % j == 0) {
                        tmp.push_back(j);
                        while(t % j == 0) t /= j;
                    }
                }
                if(t > 1) tmp.push_back(t);
                if(tmp.size() == 0) continue;
                //接下来这个循环我就看不懂了
                int nop = 0;
                int v = tmp.size();
                int nn = 1 << v;
                for(int j = 1; j < nn; j++) {
                    int flag = 0;
                    int mul = 1;
                    for(int k = 0; k < v && j >> k; k++) {
                        if((j >> k) & 1) {
                            flag++;
                            mul *= tmp[k];
                        }
                    }
                    if(flag & 1) nop += cnt[mul]; else nop -= cnt[mul];
                }
                //nop大概表示不互质的个数,因为一个数本身也会和自己不互质,所以要减1
                //ans很明显就是一个数a与另一个数b互质,a同时和另一个数c不互质的情况的个数了
                ans += (long long)max(0, nop - 1) * (n - nop);
            }
        }
        /*有些人会奇怪ans要除以2,其实ans实际上里面包括位置的不同的情况,就正如有三个位置,
        a的位置已经固定在第一个不能改变,b和c因为两个不同的位置要算两种情况,但是我们并不需要
        计较位置不同的情况,所以要除以2
        */
        printf("%I64d\n", (long long)n * (n - 1) * (n - 2) / 6 - ans / 2);
    }
    return 0;
}
/*
1
5
1 3 9 10 2
ans:4
*/



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值